Subject: Re: linux-next: build failure after merge of the net-next tree

From: Kalle Valo <[email-masked]>
Date: Fri, 08 Oct 2021 17:43:39 +0300

Hi Geert,

Geert Uytterhoeven <[email-masked]> writes:

> On Fri, Oct 8, 2021 at 7:55 AM Kalle Valo <[email-masked]> wrote:
>> Stephen Rothwell <[email-masked]> writes:
>>
>> > After merging the net-next tree, today's linux-next build (xtensa,
>> > m68k allmodconfig) failed like this:
>> >
>> > In file included from <command-line>:0:0:
>> > In function 'ath11k_peer_assoc_h_smps',
>> >     inlined from 'ath11k_peer_assoc_prepare' at drivers/net/wireless/ath/ath11k/mac.c:2362:2:
>> > include/linux/compiler_types.h:317:38: error: call to '__compiletime_assert_650' declared with attribute error: FIELD_GET: type of reg too small for mask
>> >   _compiletime_assert(condition, msg, __compiletime_assert_, __COUNTER__)
>> >                                       ^
>> > include/linux/compiler_types.h:298:4: note: in definition of macro '__compiletime_assert'
>> >     prefix ## suffix();    \
>> >     ^
>> > include/linux/compiler_types.h:317:2: note: in expansion of macro '_compiletime_assert'
>> >   _compiletime_assert(condition, msg, __compiletime_assert_, __COUNTER__)
>> >   ^
>> > include/linux/build_bug.h:39:37: note: in expansion of macro 'compiletime_assert'
>> >  #define BUILD_BUG_ON_MSG(cond, msg) compiletime_assert(!(cond), msg)
>> >                                      ^
>> > include/linux/bitfield.h:52:3: note: in expansion of macro 'BUILD_BUG_ON_MSG'
>> >    BUILD_BUG_ON_MSG((_mask) > (typeof(_reg))~0ull,  \
>> >    ^
>> > include/linux/bitfield.h:108:3: note: in expansion of macro '__BF_FIELD_CHECK'
>> >    __BF_FIELD_CHECK(_mask, _reg, 0U, "FIELD_GET: "); \
>> >    ^
>> > drivers/net/wireless/ath/ath11k/mac.c:2079:10: note: in expansion of macro 'FIELD_GET'
>> >    smps = FIELD_GET(IEEE80211_HE_6GHZ_CAP_SM_PS,
>> >           ^
>> >
>> > Caused by commit
>> >
>> >   6f4d70308e5e ("ath11k: support SMPS configuration for 6 GHz")
>>
>> Thanks for the report, weird that I don't see it on x86. I can't look at
>> this in detail now, maybe later today, but I wonder if the diff below
>> fixes the issue?
>
> It seems to be related to passing "le16_to_cpu(sta->he_6ghz_capa.capa)".
> Probably typeof(le16_to_cpu(sta->he_6ghz_capa.capa)) goes berserk.
> le16_to_cpu() is a complex macro on big-endian. I had expected to see
> a similar issue on powerpc, but I don't.
> Using an intermediate "u16 capa = le16_to_cpu(sta->he_6ghz_capa.capa)"
> fixes the problem.
>
>> At least it's cleaner than using FIELD_GET(), actually ath11k should be
>> cleaned up to use xx_get_bits() all over.
>>
>> Kalle
>>
>> diff --git a/drivers/net/wireless/ath/ath11k/mac.c b/drivers/net/wireless/ath/ath11k/mac.c
>> index d897020dd52d..3e7e569f284b 100644
>> --- a/drivers/net/wireless/ath/ath11k/mac.c
>> +++ b/drivers/net/wireless/ath/ath11k/mac.c
>> @@ -2076,8 +2076,8 @@ static void ath11k_peer_assoc_h_smps(struct ieee80211_sta *sta,
>>                 smps = ht_cap->cap & IEEE80211_HT_CAP_SM_PS;
>>                 smps >>= IEEE80211_HT_CAP_SM_PS_SHIFT;
>>         } else {
>> -               smps = FIELD_GET(IEEE80211_HE_6GHZ_CAP_SM_PS,
>> -                                le16_to_cpu(sta->he_6ghz_capa.capa));
>> +               smps = le16_get_bits(sta->he_6ghz_capa.capa,
>> +                                    IEEE80211_HE_6GHZ_CAP_SM_PS);
>>         }
>
> Thanks, that works, too, so (compile)
> Tested-by: Geert Uytterhoeven <[email-masked]>

Thanks Geert, you helped a lot! I now submitted a patch to netdev:

https://patchwork.kernel.org/project/netdevbpf/patch/[email-masked]/

Dave & Jakub, if you can please take the patch directly to net-next.

-- 
https://patchwork.kernel.org/project/linux-wireless/list/

https://wireless.wiki.kernel.org/en/developers/documentation/submittingpatches